clear
clc

global Ir It Il etat_init K1 K2 rotation_orbitale phimax H0 rappel_integral couple_desat
global couple_tuyere top ton K ecart_temps coeff_couple coeff_desature Hmax Hmin
global gain_desat_magn moment_magnetique magneto

% Ce fichier de donnes initialise la simulation mom_sim.m

altitude=470; % en km
rotation_orbitale=(39.86e4/(6378+altitude)^3)^0.5;

% Inerties satellite en kg-m 

Il=300;It=500;Ir=400;

% Initialisation en vitesses angulaires absolues (rd/s)

v_roulis0=0;
v_tangage0=0;
v_lacet0=0;

% INITIALISATION DES POSITIONS ANGULAIRES EN rd
roulis0=0.02;
tangage0=0.02;
lacet0=0.02;

% LE MOMENT CINETIQUE EST PORTE PAR Y ET VAUT Hy=20 N-m-s  t=0
% Dans les quations c'est H=-Hy qui apparat de valeur initiale H0

H0=-20; % En Nms

% Contrle en dsaturation, niveaux des couples admissibles

Hmax=1.006*H0;Hmin=H0/2;

% CAS1: fonctionnement nominal K1=0;K2=0; 

% CAS 2: EN DESATURATION ET COMMANDE P.D
% K1=0.05;K2=22.2;

% DESATURATION EN PID, AVEC K1 ET K2 MULTIPLIES PAR 2
 rappel_integral=1/1000; % coefficient du rappel intgral( voir programme desature.m)
 K1=0.1;K2=44.4;


% DONNEES RELATIVES AU CONTROLE PAR TUYERES ET SEUIL EN ROULIS

% Seuil roulis 1.5

phimax=1.5*pi/180;

% ********************  INITIALISATION DES TOPS  *****************

top=0;
ton=0;
K=0;

% *************************************************************************

ecart_temps=pi*(Ir*Il)^0.5/H0; % Demi priode de la nutation T2

coeff_couple=0.4; % Possibilit de faire varier le niveau du couple de commande sur seuil

couple_tuyere=abs(H0)*phimax*coeff_couple;

couple_desat=couple_tuyere/100;

                                      magneto=1;

% *******************************   FIN  DES TUYERES  *************************

% ----------- LES 2 DESATURATIONS S'EXCLUENT MUTUELLEMENT --------------------
% Il suffit de dsactiver les lignes en faisant     magneto=0 sinon magneto=1
% juste au dessus de ce bout de programme

if magneto==1,
  % **********************   DESATURATION PAR MAGNETOCOUPLEURS ******************
  % Choix d'un tangage rduit pour simuler le rgime permanent
  tangage0=0.2*pi/180;
  % Choix d'un gain et du moment magntique d'une bobine.
  gain_desat_magn=1;moment_magnetique=20;% ( Moment en A-m)

  % donnes magntiques:
  mu0=4*pi*1e-7;Kmagn=6.413e21;coeff=mu0*Kmagn/((6378+altitude)*1000)^3;

  % Conservation de la commande roue pour viter les -coups
  K1=0.8;K2=70;

end
% ETAT INITIAL
etat_init=[roulis0 tangage0 lacet0 v_roulis0 v_tangage0 v_lacet0 H0]; 

% **********************  FIN MAGNETOCOUPLEURS *****************************
end
% **************************  FIN PROGRAMME  **************************
