clear
clc

global Ir It Il etat_init rotation_orbitale altitude Kg Kr Kt Kl coeff

% Ce fichier initialise la simulation magn_sim.m

altitude=470;  % en km

rotation_orbitale=(39.86e4/(6378+altitude)^3)^0.5;

% Inerties satellite en kg-m 

% Ir=132;
% It=137;
% Il=7;

Il=300;Ir=400;It=500;

% GAIN DES MAGNETOCOUPLEURS ET CONSTANTES

Kr=10000;Kt=2500;Kl=50000;Kg=0;

mu0=4*pi*1e-7;

Kmagn=6.413e21;

coeff=mu0*Kmagn/((6378+altitude)*1000)^3;

% ***************                         *************
% Initialisation en vitesses angulaires absolues (rd/s)
v_roulis0=0.0003;v_tangage0=0.0002;v_lacet0=0.0001;

% Initialisation en position (rd)
roulis0=0.02;tangage0=0.05;lacet0=0.04;



% ********************** ACQUISITION INVERSE *************
% Initialisation en vitesses angulaires absolues (rd/s)
v_roulis0=0.01;v_tangage0=0.005;v_lacet0=0.0002;

% Initialisation en position (rd)
roulis0=0.1;tangage0=0.5;lacet0=0.15;

% ********************** ACQUISITION NORMALE *************
% Initialisation en vitesses angulaires absolues (rd/s)
v_roulis0=0.01;v_tangage0=0.002;v_lacet0=0.0002;

% Initialisation en position (rd)
roulis0=0.1;tangage0=0.2;lacet0=0.15;

% *************TANGAGE SEUL ACQUISITION NORMALE 1 TOUR*************
% Initialisation en vitesses angulaires absolues (rd/s)
v_roulis0=0;v_tangage0=0.003;v_lacet0=0;

% Initialisation en position (rd)
roulis0=0;tangage0=0.6;lacet0=0;

% *************TANGAGE SEUL ACQUISITION NORMALE 1 TOUR*************
% Initialisation en vitesses angulaires absolues (rd/s)
Kt=10000;
v_roulis0=0;v_tangage0=0.008;v_lacet0=0;

% Initialisation en position (rd)
roulis0=0;tangage0=0.6;lacet0=0;

% **********************                     *************
                 
% ***** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********

vp0=v_roulis0+v_lacet0*sin(tangage0)+...
    rotation_orbitale*sin(lacet0)*cos(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0)+...
    rotation_orbitale*(cos(lacet0)*cos(roulis0)+...
    sin(tangage0)*sin(roulis0)*sin(lacet0));

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0)+...
    rotation_orbitale*(-cos(lacet0)*sin(roulis0)+...
    sin(tangage0)*cos(roulis0)*sin(lacet0));
   

% ---- Calcul du quaternion initial connaissant les angles initiaux

% Matrice de passage P de la base fixe  la base satellite
%  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

% Calcul du quaternion initial
%
% Nous prenons toujours q0 >0 ou nul

trac=trace(Pmat);

qt00=(1+trac)^0.5/2;

qt10=(1-trac+2*Pmat(1,1))^0.5/2;

qt20=(1-trac+2*Pmat(2,2))^0.5/2;

qt30=(1-trac+2*Pmat(3,3))^0.5/2;

if abs(qt00)>1e-8, 
qt10=qt10*sign((Pmat(3,2)-Pmat(2,3))/4/qt00);
qt20=qt20*sign((Pmat(1,3)-Pmat(3,1))/4/qt00);
qt30=qt30*sign((-Pmat(1,2)+Pmat(2,1))/4/qt00);
end

if abs(qt10)>1e-8, 

qt20=qt20*sign((Pmat(1,2)+Pmat(2,1))/4/qt10);
qt30=qt30*sign((Pmat(1,3)+Pmat(3,1))/4/qt10);
qt00=qt00*sign((Pmat(3,2)-Pmat(2,3))/4/qt10);
end

if abs(qt20)>1e-8, 
qt10=qt10*sign((Pmat(1,2)+Pmat(2,1))/4/qt20);
qt30=qt30*sign((Pmat(2,3)+Pmat(3,2))/4/qt20);
qt00=qt00*sign((Pmat(1,3)-Pmat(3,1))/4/qt20);
end

if abs(qt30)>1e-8, 
qt20=qt20*sign((Pmat(3,2)+Pmat(2,3))/4/qt30);
qt10=qt10*sign((Pmat(1,3)+Pmat(3,1))/4/qt30);
qt00=qt00*sign((-Pmat(1,2)+Pmat(2,1))/4/qt30);
end

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

etat_init=[vp0 vq0 vr0 qt00 qt10 qt20 qt30]; 

clear trac altitude qt00 qt10 qt20 qt30 vp0 vq0 vr0 Q Pmat

end








