% VISUALISATION DES ANGLES DE ROULIS LACET ET TANGAGE D'UN 
% SATELLITE ETUDIE PAR LES QUATERNIONS (valeurs relles)

% Rcupration du quaternion

Q=solution(:,4:7);

% Initialisation des variables du trac

var_temps=[];
var_roulis=[];
var_tangage=[];
var_lacet=[];

memoire=[];

n=length(temps);

for k=1:n,

  Q0=Q(k,1);Q1=Q(k,2);Q2=Q(k,3);Q3=Q(k,4);
  P31=2*(Q1*Q3-Q0*Q2);
  P33=2*(Q0^2+Q3^2)-1;
  P11=2*(Q0^2+Q1^2)-1;
  P21=2*(Q1*Q2+Q0*Q3);
  P32=2*(Q2*Q3+Q0*Q1);

    if abs(P31)<0.9999,

	% CALCUL ROULIS
	z_roulis=P33+i*P32;
	var_roulis=[var_roulis angle(z_roulis)];

	% CALCUL LACET
	z_lacet=P11+i*P21;
	var_lacet=[var_lacet angle(z_lacet)];

	% CALCUL TANGAGE
	if abs(sin(angle(z_roulis)))>0.01,
		X=P32/sin(angle(z_roulis));
	else
		X=P33/cos(angle(z_roulis));
	end
	z_tangage=X-i*P31;
	var_tangage=[var_tangage angle(z_tangage)];
	
	% MEMORISATION DU TEMPS
	var_temps=[var_temps temps(k)];
    end
end

% Rgularisation des courbes (continuit des angles)
% Sortie des angles en degrs

if max(abs(sin(var_roulis)))<0.01,
	var_roulis=zeros(size(var_roulis));
else
	var_roulis=unwrap(var_roulis);	
end
subplot(2,2,1);
plot(var_temps,180/pi*var_roulis,'r');
title('ROULIS (en degrs)');


if max(abs(sin(var_lacet)))<0.01,
	var_lacet=zeros(size(var_lacet));
else
	var_lacet=unwrap(var_lacet);	
end

subplot(2,2,2);
plot(var_temps,var_lacet,'g');
title('LACET (en degrs)');

subplot(2,2,3);
var_tangage=unwrap(var_tangage);
plot(var_temps,180/pi*var_tangage,'b');
title('TANGAGE (en degrs)');

figure(gcf)

% subplot(1,1,1);
end