function y=derivsys(u);

% **************************************************
% CETTE FONCTION SERT AU CAS DE LA STABILISATION PAR
% MOMENT EMBARQUE ET CONTROLE PAR TUYERES
% LE CAS TRAITE EST CELUI DES PETITS ANGLES

% ***********  MODE DE POINTAGE FIN  ***************

% **************************************************

global It Ir Il etat_init rotation_orbitale K1 K2 temps

% ************************************************
% Le vecteur d'entre pour le traitement du systme
% diffrentiel u est  7 composantes.
%
%	u(1)=Phi    angle de cardan / x  pour des angles petits
%	u(2)=Teta   angle de cardan / y  pour des angles petits
%	u(3)=Psi    angle de cardan / z  pour des angles petits
%	u(4)=Phi'  drive de Phi
%	u(5)=Teta' drive de Teta
%	u(6)=Psi'  drive de psi
%	u(7)=H     Moment cintique embarqu, sur y
% *************************************************

w0=rotation_orbitale;H=u(7);

% Calcul des drives de Phi Teta psi, Le moment H est sur l'axe y
% ***************  Drives des 3 angles *********************
d1=u(4);
d2=u(5);
d3=u(6);

% ****** Drives des 3 drives premires ( quations du mouvement)********

% Equation en Phi(drive d'ordre 2)
   d4=(H*w0/Ir)*u(1)-(w0+H/Ir)*u(6);
% EQUATION EN TETA AVEC CONTROLE PD( Proportionnel-drive), GRCE A LA DERIVEE DE H
% (drive d'ordre 2)
   d5=(-K1*u(2)-K2*u(5))/It; 
% EQUATION EN PSI (drive d'ordre 2)
   d6=(H*w0/Il)*u(3)+(w0+H/Il)*u(4);
% EQUATION D'EVOLUTION DU MOMENT CINETIQUE EMBARQUE H( Pas Hy mais H=-Hy)dans le PD
% (drive d'ordre 1)
   d7=-K1*u(2)-K2*u(5);

y=[d1;d2;d3;d4;d5;d6;d7];

% ************************ FIN ********************************